package cn.ibizlab.core.sample.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.core.sample.domain.IBIZSample0015;
import cn.ibizlab.core.sample.filter.IBIZSample0015SearchContext;
import cn.ibizlab.core.sample.service.IIBIZSample0015Service;

import cn.ibizlab.util.helper.CachedBeanCopier;
import cn.ibizlab.util.helper.DEFieldCacheMap;
import com.alibaba.fastjson.JSONObject;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.core.sample.mapper.IBIZSample0015Mapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import org.springframework.util.StringUtils;

/**
 * 实体[项目] 服务对象接口实现
 */
@Slf4j
@Service("IBIZSample0015ServiceImpl")
public class IBIZSample0015ServiceImpl extends ServiceImpl<IBIZSample0015Mapper, IBIZSample0015> implements IIBIZSample0015Service {

    @Autowired
    @Lazy
    protected cn.ibizlab.core.sample.service.IIBIZSample0016Service ibizsample0016Service;

    protected int batchSize = 500;

    @Override
    @Transactional
    public boolean create(IBIZSample0015 et) {
        if(!this.retBool(this.baseMapper.insert(et))) {
            return false;
        }
        CachedBeanCopier.copy(get(et.getIbizsample0015id()), et);
        return true;
    }

    @Override
    @Transactional
    public void createBatch(List<IBIZSample0015> list) {
        this.saveBatch(list, batchSize);
    }

    @Override
    @Transactional
    public boolean update(IBIZSample0015 et) {
        if(!update(et, (Wrapper) et.getUpdateWrapper(true).eq("ibizsample0015id", et.getIbizsample0015id()))) {
            return false;
        }
        CachedBeanCopier.copy(get(et.getIbizsample0015id()), et);
        return true;
    }

    @Override
    @Transactional
    public void updateBatch(List<IBIZSample0015> list) {
        updateBatchById(list, batchSize);
    }

    @Override
    @Transactional
    public boolean remove(String key) {
        boolean result = removeById(key);
        return result ;
    }

    @Override
    @Transactional
    public void removeBatch(Collection<String> idList) {
        removeByIds(idList);
    }

    @Override
    @Transactional
    public IBIZSample0015 get(String key) {
        IBIZSample0015 et = getById(key);
        if (et == null) {
            throw new BadRequestAlertException("数据不存在", this.getClass().getSimpleName(), key);
        }
        else {
        }
        return et;
    }

    @Override
    public IBIZSample0015 getDraft(IBIZSample0015 et) {
        return et;
    }

    @Override
    public boolean checkKey(IBIZSample0015 et) {
        return (!ObjectUtils.isEmpty(et.getIbizsample0015id())) && (!Objects.isNull(this.getById(et.getIbizsample0015id())));
    }
    @Override
    @Transactional
    public boolean save(IBIZSample0015 et) {
        if(!saveOrUpdate(et)) {
            return false;
        }
        return true;
    }

    @Override
    @Transactional
    public boolean saveOrUpdate(IBIZSample0015 et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? getProxyService().update(et) : getProxyService().create(et);
        }
    }

    @Override
    @Transactional
    public boolean saveBatch(Collection<IBIZSample0015> list) {
        List<IBIZSample0015> create = new ArrayList<>();
        List<IBIZSample0015> update = new ArrayList<>();
        for (IBIZSample0015 et : list) {
            if (ObjectUtils.isEmpty(et.getIbizsample0015id()) || ObjectUtils.isEmpty(getById(et.getIbizsample0015id()))) {
                create.add(et);
            } else {
                update.add(et);
            }
        }
        if (create.size() > 0) {
            getProxyService().createBatch(create);
        }
        if (update.size() > 0) {
            getProxyService().updateBatch(update);
        }
        return true;
    }

    @Override
    @Transactional
    public void saveBatch(List<IBIZSample0015> list) {
        List<IBIZSample0015> create = new ArrayList<>();
        List<IBIZSample0015> update = new ArrayList<>();
        for (IBIZSample0015 et : list) {
            if (ObjectUtils.isEmpty(et.getIbizsample0015id()) || ObjectUtils.isEmpty(getById(et.getIbizsample0015id()))) {
                create.add(et);
            } else {
                update.add(et);
            }
        }
        if (create.size() > 0) {
            getProxyService().createBatch(create);
        }
        if (update.size() > 0) {
            getProxyService().updateBatch(update);
        }
    }



    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<IBIZSample0015> searchDefault(IBIZSample0015SearchContext context) {
            com.baomidou.mybatisplus.extension.plugins.pagination.Page<IBIZSample0015> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
            return new PageImpl<IBIZSample0015>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }







    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

    @Override
    public List<IBIZSample0015> getIbizsample0015ByIds(List<String> ids) {
         return this.listByIds(ids);
    }

    @Override
    public List<IBIZSample0015> getIbizsample0015ByEntities(List<IBIZSample0015> entities) {
        List ids =new ArrayList();
        for(IBIZSample0015 entity : entities){
            Serializable id=entity.getIbizsample0015id();
            if(!ObjectUtils.isEmpty(id)){
                ids.add(id);
            }
        }
        if(ids.size()>0) {
            return this.listByIds(ids);
        }
        else {
            return entities;
        }
    }




    public IIBIZSample0015Service getProxyService() {
        return cn.ibizlab.util.security.SpringContextHolder.getBean(this.getClass());
    }
}



